/* -*- mode: C; c-file-style: "gnu" -*- */
/* dbus-address.h  Server address parser.
 *
 * Copyright (C) 2003  CodeFactory AB
 *
 * Licensed under the Academic Free License version 2.1
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
module org.freedesktop.dbus.c.Address;

import org.freedesktop.dbus.c.Types;
import org.freedesktop.dbus.c.Errors;

extern(C):

/**
 * @addtogroup DBusAddress
 * @{
 */

/** Opaque type representing one of the semicolon-separated items in an address */
struct DBusAddressEntry {};

dbus_bool_t dbus_parse_address            (char               *address,
					   DBusAddressEntry ***entry,
					   int                *array_len,
					   DBusError          *error);
char *dbus_address_entry_get_value  (DBusAddressEntry   *entry,
					   char               *key);
char *dbus_address_entry_get_method (DBusAddressEntry   *entry);
void        dbus_address_entries_free     (DBusAddressEntry  **entries);

char* dbus_address_escape_value   (char *value);
char* dbus_address_unescape_value (char *value,
                                   DBusError  *error);

/** @} */


